---
title: AuthenticatorAttestationResponse
slug: Web/API/AuthenticatorAttestationResponse
tags:
  - API
  - Authentication
  - AuthenticatorAttestationResponse
  - Interface
  - Reference
  - Web Authentication API
  - WebAuthn
---
<div>{{APIRef("Web Authentication API")}}{{securecontext_header}}</div>

<p>The <strong><code>AuthenticatorAttestationResponse</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> is returned by {{domxref('CredentialsContainer.create()')}} when a {{domxref('PublicKeyCredential')}} is passed, and provides a cryptographic root of trust for the new key pair that has been generated. This response should be sent to the relying party's server to complete the creation of the credential.</p>

<p>This interface inherites from {{domxref("AuthenticatorResponse")}}.</p>

<div class="note">
<p><strong>Note:</strong> This interface is restricted to top-level contexts. Use from within an {{HTMLElement("iframe")}} element will not have any effect.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>AuthenticatorAttestationResponse.clientDataJSON</code> {{securecontext_inline}}{{readonlyinline}}</dt>
 <dd>Client data for the authentication, such as origin and challenge. The {{domxref("AuthenticatorResponse.clientDataJSON","clientDataJSON")}} property is inherited from the {{domxref("AuthenticatorResponse")}}.</dd>
 <dt>{{domxref("AuthenticatorAttestationResponse.attestationObject")}} {{securecontext_inline}}{{readonlyinline}}</dt>
 <dd>An {{jsxref("ArrayBuffer")}} containing authenticator data and an attestation statement for a newly-created key pair.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("AuthenticatorAttestationResponse.getTransports()")}}{{securecontext_inline}}</dt>
 <dd>Returns an {{jsxref("Array")}} of strings describing which transport methods (e.g. <code>usb</code>, <code>nfc</code>) are believed to be supported with the authenticator. The array may be empty if the information is not available.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var publicKey = {
  challenge: /* from the server */,
  rp: {
    name: "Example CORP",
    id  : "login.example.com"
  },
  user: {
    id: new Uint8Array(16),
    name: "jdoe@example.com",
    displayName: "John Doe"
  },
  pubKeyCredParams: [
    {
      type: "public-key",
      alg: -7
    }
  ]
};

navigator.credentials.create({ publicKey })
  .then(function (newCredentialInfo) {
    var response = newCredentialInfo.response;
    // Do something with the response
    // (sending it back to the relying party server maybe?)
  }).catch(function (err) {
     console.error(err);
  });</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn','#authenticatorattestationresponse', 'AuthenticatorAttestationResponse interface')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AuthenticatorAttestationResponse")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("AuthenticatorAssertionResponse")}}: the interface for the type of response given when retrieving an existing credential</li>
 <li>{{domxref("AuthenticatorResponse")}}: the parent interface</li>
</ul>
